Index: trunk/kBuild/header.kmk
===================================================================
--- trunk/kBuild/header.kmk	(revision 3578)
+++ trunk/kBuild/header.kmk	(revision 3579)
@@ -1783,2 +1783,3 @@
 endif # !__header_kmk__
 
+
Index: trunk/kBuild/tools/CLANGCCMACHO.kmk
===================================================================
--- trunk/kBuild/tools/CLANGCCMACHO.kmk	(revision 3578)
+++ trunk/kBuild/tools/CLANGCCMACHO.kmk	(revision 3579)
@@ -179,5 +179,5 @@
 		--kObjCache-cpp $(outbase).i\
 		$(TOOL_CLANGCCMACHO_CC) -E -o -\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		$(abspath $(source))\
@@ -189,5 +189,5 @@
 else
 	$(QUIET)$(TOOL_CLANGCCMACHO_CC) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		-o $(obj)\
@@ -220,5 +220,5 @@
 		$(TOOL_CLANGCCMACHO_CXX) -E -o - $(if-expr defined($(target)_PCH_HDR)\
 		,-fpch-preprocess -Winvalid-pch -I$($(target)_1_GCC_PCH_DIR) -include $(basename $($(target)_1_GCC_PCH_FILE)),)\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		$(abspath $(source))\
@@ -287,5 +287,5 @@
 		--kObjCache-cpp $(outbase).ii\
 		$(TOOL_CLANGCCMACHO_OBJC) -E -o -\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		$(abspath $(source))\
@@ -301,5 +301,5 @@
 define TOOL_CLANGCCMACHO_COMPILE_OBJC_CMDS
 	$(QUIET)$(TOOL_CLANGCCMACHO_OBJC) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		-o $(obj)\
@@ -331,5 +331,5 @@
 		--kObjCache-cpp $(outbase).mii\
 		$(TOOL_CLANGCCMACHO_OBJCXX) -E -o -\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		$(abspath $(source))\
@@ -345,5 +345,5 @@
 define TOOL_CLANGCCMACHO_COMPILE_OBJCXX_CMDS
 	$(QUIET)$(TOOL_CLANGCCMACHO_OBJCXX) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		-o $(obj)\
@@ -372,5 +372,5 @@
 define TOOL_CLANGCCMACHO_COMPILE_AS_CMDS
 	$(QUIET)$(TOOL_CLANGCCMACHO_AS) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		-o $(obj)\
Index: trunk/kBuild/tools/CLANGXXMACHO.kmk
===================================================================
--- trunk/kBuild/tools/CLANGXXMACHO.kmk	(revision 3578)
+++ trunk/kBuild/tools/CLANGXXMACHO.kmk	(revision 3579)
@@ -179,5 +179,5 @@
 		--kObjCache-cpp $(outbase).i\
 		$(TOOL_CLANGXXMACHO_CC) -E -o -\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		$(abspath $(source))\
@@ -189,5 +189,5 @@
 else
 	$(QUIET)$(TOOL_CLANGXXMACHO_CC) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		-o $(obj)\
@@ -220,5 +220,5 @@
 		$(TOOL_CLANGXXMACHO_CXX) -E -o - $(if-expr defined($(target)_PCH_HDR)\
 		,-fpch-preprocess -Winvalid-pch -I$($(target)_1_GCC_PCH_DIR) -include $(basename $($(target)_1_GCC_PCH_FILE)),)\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		$(abspath $(source))\
@@ -287,5 +287,5 @@
 		--kObjCache-cpp $(outbase).ii\
 		$(TOOL_CLANGXXMACHO_OBJC) -E -o -\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		$(abspath $(source))\
@@ -301,5 +301,5 @@
 define TOOL_CLANGXXMACHO_COMPILE_OBJC_CMDS
 	$(QUIET)$(TOOL_CLANGXXMACHO_OBJC) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		-o $(obj)\
@@ -331,5 +331,5 @@
 		--kObjCache-cpp $(outbase).mii\
 		$(TOOL_CLANGXXMACHO_OBJCXX) -E -o -\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		$(abspath $(source))\
@@ -345,5 +345,5 @@
 define TOOL_CLANGXXMACHO_COMPILE_OBJCXX_CMDS
 	$(QUIET)$(TOOL_CLANGXXMACHO_OBJCXX) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		-o $(obj)\
@@ -372,5 +372,5 @@
 define TOOL_CLANGXXMACHO_COMPILE_AS_CMDS
 	$(QUIET)$(TOOL_CLANGXXMACHO_AS) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		-o $(obj)\
Index: trunk/kBuild/tools/LLVMGCC42MACHO.kmk
===================================================================
--- trunk/kBuild/tools/LLVMGCC42MACHO.kmk	(revision 3578)
+++ trunk/kBuild/tools/LLVMGCC42MACHO.kmk	(revision 3579)
@@ -158,5 +158,5 @@
 		--kObjCache-cpp $(outbase).i\
 		$(TOOL_LLVMGCC42MACHO_CC) -E -o -\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		$(abspath $(source))\
@@ -172,5 +172,5 @@
 define TOOL_LLVMGCC42MACHO_COMPILE_C_CMDS
 	$(QUIET)$(TOOL_LLVMGCC42MACHO_CC) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		-o $(obj)\
@@ -202,5 +202,5 @@
 		--kObjCache-cpp $(outbase).ii\
 		$(TOOL_LLVMGCC42MACHO_CXX) -E -o -\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		$(abspath $(source))\
@@ -216,5 +216,5 @@
 define TOOL_LLVMGCC42MACHO_COMPILE_CXX_CMDS
 	$(QUIET)$(TOOL_LLVMGCC42MACHO_CXX) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		-o $(obj)\
@@ -246,5 +246,5 @@
 		--kObjCache-cpp $(outbase).ii\
 		$(TOOL_LLVMGCC42MACHO_OBJC) -E -o -\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		$(abspath $(source))\
@@ -260,5 +260,5 @@
 define TOOL_LLVMGCC42MACHO_COMPILE_OBJC_CMDS
 	$(QUIET)$(TOOL_LLVMGCC42MACHO_OBJC) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		-o $(obj)\
@@ -290,5 +290,5 @@
 		--kObjCache-cpp $(outbase).mii\
 		$(TOOL_LLVMGCC42MACHO_OBJCXX) -E -o -\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		$(abspath $(source))\
@@ -304,5 +304,5 @@
 define TOOL_LLVMGCC42MACHO_COMPILE_OBJCXX_CMDS
 	$(QUIET)$(TOOL_LLVMGCC42MACHO_OBJCXX) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		-o $(obj)\
@@ -331,5 +331,5 @@
 define TOOL_LLVMGCC42MACHO_COMPILE_AS_CMDS
 	$(QUIET)$(TOOL_LLVMGCC42MACHO_AS) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		-o $(obj)\
Index: trunk/kBuild/tools/LLVMGXX42MACHO.kmk
===================================================================
--- trunk/kBuild/tools/LLVMGXX42MACHO.kmk	(revision 3578)
+++ trunk/kBuild/tools/LLVMGXX42MACHO.kmk	(revision 3579)
@@ -168,5 +168,5 @@
 		--kObjCache-cpp $(outbase).i\
 		$(TOOL_LLVMGXX42MACHO_CC) -E -o -\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		$(abspath $(source))\
@@ -178,5 +178,5 @@
 else
 	$(QUIET)$(TOOL_LLVMGXX42MACHO_CC) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		-o $(obj)\
@@ -209,5 +209,5 @@
 		$(TOOL_LLVMGXX42MACHO_CXX) -E -o - $(if-expr defined($(target)_PCH_HDR)\
 		,-fpch-preprocess -Winvalid-pch -I$($(target)_1_GCC_PCH_DIR) -include $(basename $($(target)_1_GCC_PCH_FILE)),)\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		$(abspath $(source))\
@@ -276,5 +276,5 @@
 		--kObjCache-cpp $(outbase).ii\
 		$(TOOL_LLVMGXX42MACHO_OBJC) -E -o -\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		$(abspath $(source))\
@@ -290,5 +290,5 @@
 define TOOL_LLVMGXX42MACHO_COMPILE_OBJC_CMDS
 	$(QUIET)$(TOOL_LLVMGXX42MACHO_OBJC) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		-o $(obj)\
@@ -320,5 +320,5 @@
 		--kObjCache-cpp $(outbase).mii\
 		$(TOOL_LLVMGXX42MACHO_OBJCXX) -E -o -\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		$(abspath $(source))\
@@ -334,5 +334,5 @@
 define TOOL_LLVMGXX42MACHO_COMPILE_OBJCXX_CMDS
 	$(QUIET)$(TOOL_LLVMGXX42MACHO_OBJCXX) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		-o $(obj)\
@@ -361,5 +361,5 @@
 define TOOL_LLVMGXX42MACHO_COMPILE_AS_CMDS
 	$(QUIET)$(TOOL_LLVMGXX42MACHO_AS) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		-o $(obj)\
Index: trunk/kBuild/tools/XGCCAMD64LINUX.kmk
===================================================================
--- trunk/kBuild/tools/XGCCAMD64LINUX.kmk	(revision 3578)
+++ trunk/kBuild/tools/XGCCAMD64LINUX.kmk	(revision 3579)
@@ -131,5 +131,5 @@
 define TOOL_XGCCAMD64LINUX_COMPILE_C_CMDS
 	$(QUIET)$(TOOL_XGCCAMD64LINUX_CC) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		-o $(obj)\
@@ -155,5 +155,5 @@
 define TOOL_XGCCAMD64LINUX_COMPILE_CXX_CMDS
 	$(QUIET)$(TOOL_XGCCAMD64LINUX_CXX) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		-o $(obj)\
@@ -179,5 +179,5 @@
 define TOOL_XGCCAMD64LINUX_COMPILE_AS_CMDS
 	$(QUIET)$(TOOL_XGCCAMD64LINUX_AS) -c\
-		$(flags) $(addprefix -I, $(incs)) $(addprefix -D, $(defs))\
+		$(flags) $(qaddprefix sh,-I, $(incs)) $(qaddprefix sh,-D, $(defs))\
 		-Wp,-MD,$(dep) -Wp,-MT,$(obj) -Wp,-MP\
 		-o $(obj)\