Index: trunk/include/VBox/com/ErrorInfo.h
===================================================================
--- trunk/include/VBox/com/ErrorInfo.h	(revision 3633)
+++ trunk/include/VBox/com/ErrorInfo.h	(revision 3634)
@@ -1,4 +1,3 @@
 /** @file
- *
  * MS COM / XPCOM Abstraction Layer:
  * ErrorInfo class declaration
@@ -21,6 +20,6 @@
  */
 
-#ifndef __VBox_com_ErrorInfo_h__
-#define __VBox_com_ErrorInfo_h__
+#ifndef ___VBox_com_ErrorInfo_h
+#define ___VBox_com_ErrorInfo_h
 
 #include "VBox/com/ptr.h"
@@ -414,4 +413,4 @@
 }; // namespace com
 
-#endif // __VBox_com_ErrorInfo_h__
-
+#endif
+
Index: trunk/include/VBox/com/EventQueue.h
===================================================================
--- trunk/include/VBox/com/EventQueue.h	(revision 3633)
+++ trunk/include/VBox/com/EventQueue.h	(revision 3634)
@@ -1,4 +1,3 @@
 /** @file
- *
  * MS COM / XPCOM Abstraction Layer:
  * Event and EventQueue class declaration
@@ -21,6 +20,6 @@
  */
 
-#ifndef __VBox_com_EventQueue_h__
-#define __VBox_com_EventQueue_h__
+#ifndef ___VBox_com_EventQueue_h
+#define ___VBox_com_EventQueue_h
 
 #if defined (__WIN__)
@@ -123,4 +122,4 @@
 }; // namespace com
 
-#endif // __VBox_com_EventQueue_h__
+#endif
 
Index: trunk/include/VBox/com/Guid.h
===================================================================
--- trunk/include/VBox/com/Guid.h	(revision 3633)
+++ trunk/include/VBox/com/Guid.h	(revision 3634)
@@ -1,4 +1,3 @@
 /** @file
- *
  * MS COM / XPCOM Abstraction Layer:
  * Guid class declaration
@@ -21,6 +20,6 @@
  */
 
-#ifndef __VBox_com_Guid_h__
-#define __VBox_com_Guid_h__
+#ifndef ___VBox_com_Guid_h
+#define ___VBox_com_Guid_h
 
 #if !defined (__WIN__)
@@ -160,4 +159,4 @@
 }; // namespace com
 
-#endif // __VBox_com_Guid_h__
+#endif
 
Index: trunk/include/VBox/com/VirtualBox.h
===================================================================
--- trunk/include/VBox/com/VirtualBox.h	(revision 3633)
+++ trunk/include/VBox/com/VirtualBox.h	(revision 3634)
@@ -1,4 +1,3 @@
 /** @file
- *
  * MS COM / XPCOM Abstraction Layer:
  * VirtualBox COM Library definitions.
@@ -33,6 +32,6 @@
  */
 
-#ifndef __VBox_com_VirtualBox_h__
-#define __VBox_com_VirtualBox_h__
+#ifndef ___VBox_com_VirtualBox_h
+#define ___VBox_com_VirtualBox_h
 
 // generated VirtualBox COM library definition file
@@ -48,3 +47,3 @@
 #include "VBox/com/defs.h"
 
-#endif // __VBox_com_VirtualBox_h__
+#endif
Index: trunk/include/VBox/com/assert.h
===================================================================
--- trunk/include/VBox/com/assert.h	(revision 3633)
+++ trunk/include/VBox/com/assert.h	(revision 3634)
@@ -1,4 +1,3 @@
 /** @file
- *
  * MS COM / XPCOM Abstraction Layer:
  * Assertion macros for COM/XPCOM
@@ -21,6 +20,6 @@
  */
 
-#ifndef __VBox_com_assert_h__
-#define __VBox_com_assert_h__
+#ifndef ___VBox_com_assert_h
+#define ___VBox_com_assert_h
 
 #include <iprt/assert.h>
@@ -247,4 +246,4 @@
 
 
-#endif // __VBox_com_assert_h__
-
+#endif
+
Index: trunk/include/VBox/com/com.h
===================================================================
--- trunk/include/VBox/com/com.h	(revision 3633)
+++ trunk/include/VBox/com/com.h	(revision 3634)
@@ -1,4 +1,3 @@
 /** @file
- *
  * MS COM / XPCOM Abstraction Layer:
  * COM initialization / shutdown
@@ -21,6 +20,6 @@
  */
 
-#ifndef __VBox_com_com_h__
-#define __VBox_com_com_h__
+#ifndef ___VBox_com_com_h
+#define ___VBox_com_com_h
 
 #include "VBox/com/defs.h"
@@ -76,4 +75,4 @@
 }; // namespace com
 
-#endif // __VBox_com_com_h__
+#endif
 
Index: trunk/include/VBox/com/defs.h
===================================================================
--- trunk/include/VBox/com/defs.h	(revision 3633)
+++ trunk/include/VBox/com/defs.h	(revision 3634)
@@ -1,4 +1,3 @@
 /** @file
- *
  * MS COM / XPCOM Abstraction Layer:
  * Common definitions
@@ -21,6 +20,6 @@
  */
 
-#ifndef __VBox_com_defs_h__
-#define __VBox_com_defs_h__
+#ifndef ___VBox_com_defs_h
+#define ___VBox_com_defs_h
 
 /*
@@ -300,4 +299,4 @@
 #endif
 
-#endif // __VBox_com_defs_h__
-
+#endif
+
Index: trunk/include/VBox/com/ptr.h
===================================================================
--- trunk/include/VBox/com/ptr.h	(revision 3633)
+++ trunk/include/VBox/com/ptr.h	(revision 3634)
@@ -1,4 +1,3 @@
 /** @file
- *
  * MS COM / XPCOM Abstraction Layer:
  * Smart COM pointer classes declaration
@@ -21,6 +20,6 @@
  */
 
-#ifndef __VBox_com_ptr_h__
-#define __VBox_com_ptr_h__
+#ifndef ___VBox_com_ptr_h
+#define ___VBox_com_ptr_h
 
 #if !defined (VBOX_WITH_XPCOM)
@@ -437,3 +436,3 @@
 };
 
-#endif // __VBox_com_ptr_h__
+#endif
Index: trunk/include/VBox/com/string.h
===================================================================
--- trunk/include/VBox/com/string.h	(revision 3633)
+++ trunk/include/VBox/com/string.h	(revision 3634)
@@ -1,4 +1,3 @@
 /** @file
- *
  * MS COM / XPCOM Abstraction Layer:
  * Smart string classes declaration
@@ -21,6 +20,6 @@
  */
 
-#ifndef __VBox_com_string_h__
-#define __VBox_com_string_h__
+#ifndef ___VBox_com_string_h
+#define ___VBox_com_string_h
 
 #if !defined(__WIN__)
@@ -546,4 +545,4 @@
 } // namespace com
 
-#endif // __VBox_com_string_h__
-
+#endif
+