Index: /trunk/src/VBox/Devices/Audio/audio.c
===================================================================
--- /trunk/src/VBox/Devices/Audio/audio.c	(revision 3669)
+++ /trunk/src/VBox/Devices/Audio/audio.c	(revision 3670)
@@ -75,5 +75,5 @@
     &dsound_audio_driver,
 #endif
-#ifdef __L4ENV__
+#ifdef RT_OS_L4
     &oss_audio_driver,
 #endif
Index: /trunk/src/VBox/Devices/Audio/ossaudio.c
===================================================================
--- /trunk/src/VBox/Devices/Audio/ossaudio.c	(revision 3669)
+++ /trunk/src/VBox/Devices/Audio/ossaudio.c	(revision 3670)
@@ -45,5 +45,5 @@
     int nfrags;
     int fragsize;
-#ifndef __L4ENV__
+#ifndef RT_OS_L4
     int mmapped;
 #endif
@@ -61,5 +61,5 @@
 
 static struct {
-#ifndef __L4ENV__
+#ifndef RT_OS_L4
     int try_mmap;
 #endif
@@ -70,5 +70,5 @@
     int debug;
 } conf = {
-#ifndef __L4ENV__
+#ifndef RT_OS_L4
     INIT_FIELD (try_mmap    =) 0,
 #endif
@@ -341,5 +341,5 @@
     st_sample_t *src;
     struct audio_buf_info abinfo;
-#ifndef __L4ENV__
+#ifndef RT_OS_L4
     struct count_info cntinfo;
 #endif
@@ -353,5 +353,5 @@
     bufsize = hw->samples << hw->info.shift;
 
-#ifndef __L4ENV__
+#ifndef RT_OS_L4
     if (oss->mmapped) {
         int bytes;
@@ -408,5 +408,5 @@
             return 0;
         }
-#ifndef __L4ENV__
+#ifndef RT_OS_L4
     }
 #endif
@@ -422,5 +422,5 @@
 
         hw->clip (dst, src, convert_samples);
-#ifdef __L4ENV__
+#ifdef RT_OS_L4
         {
 #else
@@ -466,5 +466,5 @@
     }
 
-#ifndef __L4ENV__
+#ifndef RT_OS_L4
     if (oss->mmapped) {
         oss->old_optr = cntinfo.ptr;
@@ -478,5 +478,5 @@
 static void oss_fini_out (HWVoiceOut *hw)
 {
-#ifndef __L4ENV__
+#ifndef RT_OS_L4
     int err;
 #endif
@@ -490,5 +490,5 @@
 
     if (oss->pcm_buf) {
-#ifdef __L4ENV__
+#ifdef RT_OS_L4
         qemu_free (oss->pcm_buf);
 #else
@@ -555,5 +555,5 @@
     hw->samples = (obt.nfrags * obt.fragsize) >> hw->info.shift;
 
-#ifndef __L4ENV__
+#ifndef RT_OS_L4
     oss->mmapped = 0;
     if (conf.try_mmap) {
@@ -599,5 +599,5 @@
 #endif
 
-#ifndef __L4ENV__
+#ifndef RT_OS_L4
     if (!oss->mmapped) {
 #endif
@@ -619,5 +619,5 @@
             return -1;
         }
-#ifndef __L4ENV__
+#ifndef RT_OS_L4
     }
 #endif
@@ -632,5 +632,5 @@
     OSSVoiceOut *oss = (OSSVoiceOut *) hw;
 
-#ifdef __L4ENV__
+#ifdef RT_OS_L4
     return 0;
 #else
@@ -847,5 +847,5 @@
     {"NFRAGS", AUD_OPT_INT, &conf.nfrags,
      "Number of fragments", NULL, 0},
-#ifndef __L4ENV__
+#ifndef RT_OS_L4
     {"MMAP", AUD_OPT_BOOL, &conf.try_mmap,
      "Try using memory mapped access", NULL, 0},
Index: /trunk/src/VBox/Devices/Builtins.cpp
===================================================================
--- /trunk/src/VBox/Devices/Builtins.cpp	(revision 3669)
+++ /trunk/src/VBox/Devices/Builtins.cpp	(revision 3670)
@@ -156,5 +156,5 @@
     if (VBOX_FAILURE(rc))
         return rc;
-#ifndef __L4ENV__
+#ifndef RT_OS_L4
     rc = pCallbacks->pfnRegister(pCallbacks, &g_DrvVmdkHDD);
     if (VBOX_FAILURE(rc))
@@ -190,10 +190,10 @@
         return rc;
 #endif
-#ifndef __L4ENV__
+#ifndef RT_OS_L4
     rc = pCallbacks->pfnRegister(pCallbacks, &g_DrvNAT);
     if (VBOX_FAILURE(rc))
         return rc;
 #endif
-#if defined(__L4ENV__) || defined(RT_OS_LINUX) || defined(RT_OS_WINDOWS)
+#if defined(RT_OS_L4) || defined(RT_OS_LINUX) || defined(RT_OS_WINDOWS)
     rc = pCallbacks->pfnRegister(pCallbacks, &g_DrvHostInterface);
     if (VBOX_FAILURE(rc))
@@ -219,5 +219,5 @@
 #endif
 
-#if !defined(__L4ENV__)
+#if !defined(RT_OS_L4)
     rc = pCallbacks->pfnRegister(pCallbacks, &g_DrvNamedPipe);
     if (VBOX_FAILURE(rc))
Index: /trunk/src/VBox/Devices/Storage/DrvHostBase.cpp
===================================================================
--- /trunk/src/VBox/Devices/Storage/DrvHostBase.cpp	(revision 3669)
+++ /trunk/src/VBox/Devices/Storage/DrvHostBase.cpp	(revision 3670)
@@ -38,5 +38,5 @@
 # include <VBox/scsi.h>
 
-#elif defined(__L4ENV__)
+#elif defined(RT_OS_L4)
   /* Nothing special requires... yeah, right. */
 
Index: /trunk/src/VBox/Devices/Storage/DrvHostDVD.cpp
===================================================================
--- /trunk/src/VBox/Devices/Storage/DrvHostDVD.cpp	(revision 3669)
+++ /trunk/src/VBox/Devices/Storage/DrvHostDVD.cpp	(revision 3670)
@@ -37,5 +37,5 @@
 # define USE_MEDIA_POLLING
 
-#elif defined(__L4ENV__)
+#elif defined(RT_OS_L4)
 /* nothing (yet). */
 
@@ -353,5 +353,5 @@
     }
 
-#elif defined(__L4ENV__)
+#elif defined(RT_OS_L4)
     /* Not really ported to L4 yet. */
     rc = VERR_INTERNAL_ERROR;
@@ -519,5 +519,5 @@
          */
 
-#ifndef __L4ENV__ /* Passthrough is not supported on L4 yet */
+#ifndef RT_OS_L4 /* Passthrough is not supported on L4 yet */
         bool fPassthrough;
         rc = CFGMR3QueryBool(pCfgHandle, "Passthrough", &fPassthrough);
@@ -528,5 +528,5 @@
             pThis->fReadOnlyConfig = false;
         }
-#endif /* !__L4ENV__ */
+#endif /* !RT_OS_L4 */
 
         pThis->IMount.pfnUnmount = drvHostDvdUnmount;
Index: /trunk/src/VBox/Devices/Storage/DrvHostFloppy.cpp
===================================================================
--- /trunk/src/VBox/Devices/Storage/DrvHostFloppy.cpp	(revision 3669)
+++ /trunk/src/VBox/Devices/Storage/DrvHostFloppy.cpp	(revision 3670)
@@ -36,9 +36,9 @@
 # include <dbt.h>
 
-#elif defined(__L4ENV__)
-
-#else /* !RT_OS_WINDOWS nor RT_OS_LINUX nor __L4ENV__ */
+#elif defined(RT_OS_L4)
+
+#else /* !RT_OS_WINDOWS nor RT_OS_LINUX nor RT_OS_L4 */
 # error "Unsupported Platform."
-#endif /* !RT_OS_WINDOWS nor RT_OS_LINUX nor __L4ENV__ */
+#endif /* !RT_OS_WINDOWS nor RT_OS_LINUX nor RT_OS_L4 */
 
 #include <VBox/pdm.h>
Index: /trunk/src/VBox/Frontends/VBoxBFE/DisplayImpl.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VBoxBFE/DisplayImpl.cpp	(revision 3669)
+++ /trunk/src/VBox/Frontends/VBoxBFE/DisplayImpl.cpp	(revision 3670)
@@ -41,5 +41,5 @@
 #include <iprt/asm.h>
 
-#ifdef __L4__
+#ifdef RT_OS_L4
 #include <stdio.h>
 #include <l4/util/util.h>
@@ -396,5 +396,5 @@
     while(!mFramebuffer)
     {
-#if __L4__
+#if RT_OS_L4
       asm volatile ("nop":::"memory");
       l4_sleep(5);
Index: /trunk/src/VBox/Frontends/VBoxBFE/HostUSBImpl.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VBoxBFE/HostUSBImpl.cpp	(revision 3669)
+++ /trunk/src/VBox/Frontends/VBoxBFE/HostUSBImpl.cpp	(revision 3670)
@@ -91,5 +91,5 @@
     mUSBProxyService = new USBProxyServiceWin32 (this);
 */
-#ifdef __L4__
+#ifdef RT_OS_L4
     mUSBProxyService = new USBProxyServiceLinux (this);
 #else
Index: /trunk/src/VBox/Frontends/VBoxBFE/MouseImpl.h
===================================================================
--- /trunk/src/VBox/Frontends/VBoxBFE/MouseImpl.h	(revision 3669)
+++ /trunk/src/VBox/Frontends/VBoxBFE/MouseImpl.h	(revision 3670)
@@ -55,5 +55,5 @@
     int  setAbsoluteCoordinates(bool fAbsolute);
     int  setNeedsHostCursor(bool fNeedsHostCursor);
-#ifdef __L4ENV__
+#ifdef RT_OS_L4
     // So far L4Con does not support an own mouse pointer.
     bool getAbsoluteCoordinates() { return false; }
Index: /trunk/src/VBox/Frontends/VBoxBFE/USBProxyService.h
===================================================================
--- /trunk/src/VBox/Frontends/VBoxBFE/USBProxyService.h	(revision 3669)
+++ /trunk/src/VBox/Frontends/VBoxBFE/USBProxyService.h	(revision 3670)
@@ -178,5 +178,5 @@
 
 
-#if defined(RT_OS_LINUX) || defined(__L4__)
+#if defined(RT_OS_LINUX) || defined(RT_OS_L4)
 #include <stdio.h>
 
Index: /trunk/src/VBox/Frontends/VBoxBFE/VBoxBFE.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VBoxBFE/VBoxBFE.cpp	(revision 3669)
+++ /trunk/src/VBox/Frontends/VBoxBFE/VBoxBFE.cpp	(revision 3670)
@@ -65,5 +65,5 @@
 #include <errno.h>
 
-#if defined(RT_OS_LINUX) || defined(__L4__)
+#if defined(RT_OS_LINUX) || defined(RT_OS_L4)
 #include <fcntl.h>
 #include <net/if.h>
@@ -72,5 +72,5 @@
 #endif
 
-#ifndef __L4ENV__
+#ifndef RT_OS_L4
 #include <vector>
 #endif
@@ -88,15 +88,15 @@
 #endif
 
-#if defined(USE_SDL) && ! defined(__L4__)
+#if defined(USE_SDL) && ! defined(RT_OS_L4)
 #include "SDLConsole.h"
 #include "SDLFramebuffer.h"
 #endif
 
-#ifdef __L4__
+#ifdef RT_OS_L4
 #include "L4Console.h"
 #include "L4Framebuffer.h"
 #endif
 
-#ifdef __L4ENV__
+#ifdef RT_OS_L4
 # ifndef L4API_l4v2onv4
 #  include <l4/sys/ktrace.h>
@@ -145,5 +145,5 @@
 
 /** flag whether keyboard/mouse events are grabbed */
-#ifdef __L4__
+#ifdef RT_OS_L4
 /** see <l4/input/macros.h> for key definitions */
 int gHostKey; /* not used */
@@ -321,5 +321,5 @@
              "  -[no]csam          Enable or disable CSAM\n"
 #endif
-#ifdef __L4ENV__
+#ifdef RT_OS_L4
              "  -env <var=value>   Set the given environment variable to \"value\"\n"
 #endif
@@ -331,5 +331,5 @@
 int main(int argc, char **argv)
 {
-#ifdef __L4ENV__
+#ifdef RT_OS_L4
 #ifndef L4API_l4v2onv4
     /* clear Fiasco kernel trace buffer */
@@ -347,5 +347,5 @@
                 return SyntaxError("Error setting environment string %s.\n", argv[i]);
         }
-#endif /* __L4ENV__ */
+#endif /* RT_OS_L4 */
 
     /*
@@ -632,8 +632,8 @@
             g_fCSAM = false;
 #endif /* VBOXSDL_ADVANCED_OPTIONS */
-#ifdef __L4__
+#ifdef RT_OS_L4
         else if (strcmp(pszArg, "-env") == 0)
             ++curArg;
-#endif /* __L4__ */
+#endif /* RT_OS_L4 */
         /* just show the help screen */
         else
@@ -655,5 +655,5 @@
     gConsole = new SDLConsole();
     gFramebuffer = new SDLFramebuffer();
-#elif defined(__L4ENV__)
+#elif defined(RT_OS_L4)
     gConsole = new L4Console();
     gFramebuffer = new L4Framebuffer();
@@ -725,5 +725,5 @@
     gConsole->updateTitlebar();
 
-#ifdef __L4__
+#ifdef RT_OS_L4
     /* The L4 console provides (currently) a fixed resolution. */
     if (g_u32VRamSizeMB * _1M >=   gFramebuffer->getHostXres() 
@@ -996,5 +996,5 @@
 #endif /* VBOXBFE_WITH_USB */
 
-#ifdef __L4ENV__
+#ifdef RT_OS_L4
     /* L4 console cannot draw a host cursor */
     gMouse->setHostCursor(false);
@@ -1343,5 +1343,5 @@
     rc = CFGMR3InsertInteger(pCfg,  "VRamSize",       g_u32VRamSizeMB * _1M);       UPDATE_RC();
 
-#ifdef __L4ENV__
+#ifdef RT_OS_L4
     /* XXX hard-coded */
     rc = CFGMR3InsertInteger(pCfg,  "HeightReduction", 18);                         UPDATE_RC();
@@ -1490,5 +1490,5 @@
 #endif
                 {
-#if defined (RT_OS_LINUX) || defined (__L4__)
+#if defined (RT_OS_LINUX) || defined (RT_OS_L4)
                     /*
                      * Create/Open the TAP the device.
@@ -1550,5 +1550,5 @@
 
 
-#else /* !RT_OS_LINUX && !__L4__ */
+#else /* !RT_OS_LINUX && !RT_OS_L4 */
                     FatalError("Name based HIF devices not implemented yet for this host platform\n");
                     return VERR_NOT_IMPLEMENTED;
@@ -1604,5 +1604,5 @@
 #elif defined(RT_OS_LINUX)
         rc = CFGMR3InsertString(pCfg, "AudioDriver",      "oss");                   UPDATE_RC();
-#elif defined(__L4ENV__)
+#elif defined(RT_OS_L4)
         rc = CFGMR3InsertString(pCfg, "AudioDriver",      "oss");                   UPDATE_RC();
 #else /* portme */
Index: /trunk/src/VBox/Frontends/VBoxBFE/VMMDevInterface.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VBoxBFE/VMMDevInterface.cpp	(revision 3669)
+++ /trunk/src/VBox/Frontends/VBoxBFE/VMMDevInterface.cpp	(revision 3670)
@@ -43,5 +43,5 @@
 #include "ConsoleImpl.h"
 
-#ifdef __L4__
+#ifdef RT_OS_L4
 #include <l4/util/util.h> /* for l4_sleep */
 #endif
Index: /trunk/src/VBox/Main/MouseImpl.cpp
===================================================================
--- /trunk/src/VBox/Main/MouseImpl.cpp	(revision 3669)
+++ /trunk/src/VBox/Main/MouseImpl.cpp	(revision 3670)
@@ -87,5 +87,5 @@
     mParent = parent;
 
-#ifdef __L4ENV__
+#ifdef RT_OS_L4
     /* L4 console has no own mouse cursor */
     uHostCaps = VMMDEV_MOUSEHOSTCANNOTHWPOINTER;