Index: /trunk/src/VBox/Additions/common/VBoxGuestLib/SysHlp.cpp
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxGuestLib/SysHlp.cpp	(revision 3672)
+++ /trunk/src/VBox/Additions/common/VBoxGuestLib/SysHlp.cpp	(revision 3673)
@@ -27,5 +27,5 @@
 
 #include <iprt/assert.h>
-#if !defined(__WIN__) && !defined(__LINUX__)
+#if !defined(RT_OS_WINDOWS) && !defined(RT_OS_LINUX)
 #include <iprt/memobj.h>
 #endif 
@@ -36,5 +36,5 @@
     int rc = VINF_SUCCESS;
     
-#ifdef __WIN__
+#ifdef RT_OS_WINDOWS
     PMDL pMdl = IoAllocateMdl (pv, u32Size, FALSE, FALSE, NULL);
 
@@ -60,5 +60,5 @@
     }
 
-#elif defined(__LINUX__)
+#elif defined(RT_OS_LINUX)
     NOREF(ppvCtx);
     NOREF(pv);
@@ -84,5 +84,5 @@
     NOREF(u32Size);
 
-#ifdef __WIN__
+#ifdef RT_OS_WINDOWS
     PMDL pMdl = (PMDL)pvCtx;
 
@@ -93,5 +93,5 @@
     }
 
-#elif defined(__LINUX__)
+#elif defined(RT_OS_LINUX)
     NOREF(pvCtx);
 
@@ -107,5 +107,5 @@
 #ifndef VBGL_VBOXGUEST
 
-#if defined (__LINUX__) && !defined (__KERNEL__)
+#if defined (RT_OS_LINUX) && !defined (__KERNEL__)
 # include <unistd.h>
 # include <errno.h>
@@ -114,5 +114,5 @@
 #endif
 
-#ifdef __LINUX__
+#ifdef RT_OS_LINUX
 __BEGIN_DECLS
 extern DECLVBGL(void *) vboxadd_cmc_open (void);
@@ -120,7 +120,7 @@
 extern DECLVBGL(int) vboxadd_cmc_call (void *opaque, uint32_t func, void *data);
 __END_DECLS
-#endif /* __LINUX__ */
-
-#ifdef __OS2__
+#endif /* RT_OS_LINUX */
+
+#ifdef RT_OS_OS2
 __BEGIN_DECLS
 /* 
@@ -136,5 +136,5 @@
 int vbglDriverOpen (VBGLDRIVER *pDriver)
 {
-#ifdef __WIN__
+#ifdef RT_OS_WINDOWS
     UNICODE_STRING uszDeviceName;
     RtlInitUnicodeString (&uszDeviceName, L"\\Device\\VBoxGuest");
@@ -157,5 +157,5 @@
     return rc;
 
-#elif defined (__LINUX__)
+#elif defined (RT_OS_LINUX)
     void *opaque;
 
@@ -168,5 +168,5 @@
     return VINF_SUCCESS;
 
-#elif defined (__OS2__)
+#elif defined (RT_OS_OS2)
     /* 
      * Just check whether the connection was made or not.
@@ -190,5 +190,5 @@
 int vbglDriverIOCtl (VBGLDRIVER *pDriver, uint32_t u32Function, void *pvData, uint32_t cbData)
 {
-#ifdef __WIN__
+#ifdef RT_OS_WINDOWS
     IO_STATUS_BLOCK ioStatusBlock;
 
@@ -230,8 +230,8 @@
     return NT_SUCCESS(rc)? VINF_SUCCESS: VERR_VBGL_IOCTL_FAILED;
 
-#elif defined (__LINUX__)
+#elif defined (RT_OS_LINUX)
     return vboxadd_cmc_call (pDriver->opaque, u32Function, pvData);
 
-#elif defined (__OS2__)
+#elif defined (RT_OS_OS2)
     if (    pDriver->u32Session 
         &&  pDriver->u32Session == g_VBoxGuestIDC.u32Session)
@@ -248,12 +248,12 @@
 void vbglDriverClose (VBGLDRIVER *pDriver)
 {
-#ifdef __WIN__
+#ifdef RT_OS_WINDOWS
     Log(("vbglDriverClose pDeviceObject=%x\n", pDriver->pDeviceObject));
     ObDereferenceObject (pDriver->pFileObject);
 
-#elif defined (__LINUX__)
+#elif defined (RT_OS_LINUX)
     vboxadd_cmc_close (pDriver->opaque);
 
-#elif defined (__OS2__)
+#elif defined (RT_OS_OS2)
     pDriver->u32Session = 0;
 
Index: /trunk/src/VBox/Additions/common/VBoxGuestLib/SysHlp.h
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxGuestLib/SysHlp.h	(revision 3672)
+++ /trunk/src/VBox/Additions/common/VBoxGuestLib/SysHlp.h	(revision 3673)
@@ -24,5 +24,5 @@
 #define __SYSHLP__H
 
-#ifdef __WIN__
+#ifdef RT_OS_WINDOWS
 # if (_MSC_VER >= 1400) && !defined(VBOX_WITH_PATCHED_DDK)
 #  include <iprt/asm.h>
@@ -49,10 +49,10 @@
 typedef struct _VBGLDRIVER
 {
-#ifdef __WIN__
+#ifdef RT_OS_WINDOWS
     PDEVICE_OBJECT pDeviceObject;
     PFILE_OBJECT pFileObject;
-#elif defined (__LINUX__)
+#elif defined (RT_OS_LINUX)
     void *opaque;
-#elif defined (__OS2__)
+#elif defined (RT_OS_OS2)
     uint32_t u32Session; /**< just for sanity checking. */
 #else
Index: /trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxCalls.c
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxCalls.c	(revision 3672)
+++ /trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxCalls.c	(revision 3673)
@@ -42,5 +42,5 @@
     (a)->cParms      = SHFL_CPARMS_##b
 
-#ifndef __WIN__
+#ifndef RT_OS_WINDOWS
 # define RtlZeroMemory(a, b) memset (a, 0, b)
 #endif
Index: /trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxCalls.h
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxCalls.h	(revision 3672)
+++ /trunk/src/VBox/Additions/common/VBoxGuestLib/VBoxCalls.h	(revision 3673)
@@ -26,5 +26,5 @@
 #include <VBox/VBoxGuestLib.h>
 #ifndef _NTIFS_
-# ifdef __WIN__
+# ifdef RT_OS_WINDOWS
 #  if (_MSC_VER >= 1400) && !defined(VBOX_WITH_PATCHED_DDK)
 #   include <iprt/asm.h>
@@ -86,5 +86,5 @@
 #define DRIVE_FLAG_WRITE_PROTECTED (0x4)
 
-#ifdef __WIN__
+#ifdef RT_OS_WINDOWS
 /** Device extension structure for each drive letter we created. */
 typedef struct _VBSFDRIVE
@@ -112,5 +112,5 @@
 } VBSFDRIVE;
 typedef VBSFDRIVE *PVBSFDRIVE;
-#endif /* __WIN__ */
+#endif /* RT_OS_WINDOWS */
 
 /* forward decl */